Bug 150821 - Implement text-combine-upright (new version of -webkit-text-combine)
Summary: Implement text-combine-upright (new version of -webkit-text-combine)
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: Layout and Rendering (show other bugs)
Version: WebKit Nightly Build
Hardware: Unspecified Unspecified
: P2 Normal
Assignee: Tim Nguyen (:ntim)
URL:
Keywords: InRadar
Depends on: 164510 234704 234705 234706 234761 234843 234694 234707
Blocks: 150822 217522
  Show dependency treegraph
 
Reported: 2015-11-02 16:06 PST by Myles C. Maxfield
Modified: 2022-01-04 07:36 PST (History)
18 users (show)

See Also:


Attachments
Patch (70.79 KB, patch)
2021-12-27 08:25 PST, Tim Nguyen (:ntim)
no flags Details | Formatted Diff | Diff
Patch (67.66 KB, patch)
2021-12-27 08:47 PST, Tim Nguyen (:ntim)
no flags Details | Formatted Diff | Diff
Patch (72.19 KB, patch)
2021-12-27 13:42 PST, Tim Nguyen (:ntim)
dino: review+
Details | Formatted Diff | Diff
Patch (72.37 KB, patch)
2021-12-30 16:24 PST, Tim Nguyen (:ntim)
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Myles C. Maxfield 2015-11-02 16:06:44 PST
The name of the property is now "text-combine-upright". In addition, the semantics of this property has changed, where the author is not required to mark up each bit of text they want to make horizontal. Instead, they just put text-combine-upright on the whole paragraph, and we do the right thing.
Comment 1 Koji Ishii 2015-11-03 08:38:00 PST
> the semantics of this property has changed

It's a bit confusing, sorry about that.

  text-combine-upright: all
is semantically equivalent to
  text-combine: horizontal
so this should be a simple renaming.

  text-combine-upright: digits <integer>?
was added to do automatic detection of digits in a row within a text run as one implementer showed an interest. But this is not implemented by other implementers yet at this point and is at risk. Probably you read this part?
Comment 2 Ryosuke Niwa 2015-11-09 12:10:14 PST
We should add the support for:
text-combine: digits 2
Comment 3 yisibl 2015-12-17 04:37:58 PST
Chrome 48 supported it.
Comment 4 r12a 2021-11-19 06:50:04 PST
Pinging this bug report in the hope that Webkit can finish making the text-combine-upright property work.  

The 'all' value is already supported in Gecko and Blink browsers, and this feature is really important for adequate handling of vertically-set text.

Supporting the 'digits' values would be good for content authors, since it requires less markup, and better semantic markup, and offers greater control.

See https://w3c.github.io/clreq/gap-analysis/#issue249_vertical_text
Comment 5 Tim Nguyen (:ntim) 2021-12-26 03:15:08 PST
Splitting this in 2 bits makes sense to me:
* Style work: Making -webkit-text-combine inherited, and implement text-combine-upright as an aliased property (with different values)

* Rendering work: Implement "digits" syntax
Comment 6 Radar WebKit Bug Importer 2021-12-26 03:17:33 PST
<rdar://problem/86913556>
Comment 7 Tim Nguyen (:ntim) 2021-12-27 08:25:59 PST
Created attachment 448001 [details]
Patch
Comment 8 Tim Nguyen (:ntim) 2021-12-27 08:47:41 PST
Created attachment 448002 [details]
Patch
Comment 9 Tim Nguyen (:ntim) 2021-12-27 13:42:18 PST
Created attachment 448006 [details]
Patch
Comment 10 Dean Jackson 2021-12-30 14:02:37 PST
Comment on attachment 448006 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=448006&action=review

> Source/WebCore/ChangeLog:9
> +        This more or less gets to Chrome parity, though there's quite a bit of work
> +        to match the standard, or even just reach Firefox parity.

Could you expand on this a bit? What still needs to be done? Are there open bugzillas?
Comment 11 Tim Nguyen (:ntim) 2021-12-30 16:24:57 PST
Created attachment 448111 [details]
Patch
Comment 12 Tim Nguyen (:ntim) 2021-12-30 16:26:47 PST
Committed r287487 (245622@trunk): <https://commits.webkit.org/245622@trunk>